--[[
	Credits
	To Shackleford for LDB-Threat  I had no clue how to write a data source
]]--

local addonName, ns = ...
local addon = CreateFrame("Frame", addonName)
local L = LibStub:GetLibrary("AceLocale-3.0"):GetLocale(addonName)

local addonversion ="r2"

local DBversion = "1"

local defaultText = "|cffC79C6ELDB|r-LagTolerance"
local defaultIcon = "Interface\\Icons\\Ability_Paladin_ShieldofVengeance"

local Color = {
	red = "ffff0000",
	yellow = "ffffff00",
	orange = "ffffa500",
}

local currentColor = ""
local currentLagTolerance = select(3, GetNetStats())
local currentSetting = GetCVar("maxSpellStartRecoveryOffset")

local LDBLagTolerance = LibStub("LibDataBroker-1.1"):NewDataObject(
	addonName, 
	{ 
		icon = defaultIcon, 
		type = "data source",
		text = defaultText,
		OnClick = function(self, button)
			addon:MouseClick(self, button)
		end
	}
	
)

_G.LibStub("AceTimer-3.0"):Embed(LDBLagTolerance)

function addon:MouseClick(frame, button)
	addon:ChangeLagTolerance()
	LDBLagTolerance:Update()
end

function addon:ChangeLagTolerance()
	currentLagTolerance = math.min(select(3, GetNetStats()),400)
	if GetCVar("reducedLagTolerance") ~= tostring(1) then
		currentSetting = 400
		return end
	if currentLagTolerance ~= 0 then 
		currentSetting = math.ceil(currentLagTolerance / 10) * 10
		SetCVar("maxSpellStartRecoveryOffset", tostring(currentSetting))
	end
end

function LDBLagTolerance:UpdateText()
	local postfix = ""
	local diff = tonumber(currentSetting - currentLagTolerance,10)
	if LDBLagToleranceDB.showDifference and math.abs(diff) ~= 0 then
		if diff > 150 or diff < -150 then
			currentColor = Color.red
		elseif diff > 80 or diff < -80 then
			currentColor = Color.orange
		elseif diff > 30 or diff < -30 then
			currentColor = Color.yellow
		else 
			currentColor = ""
		end
		
		if diff > 0 then
			if currentColor ~= "" then
				postfix = ' (|c'..currentColor..'+'..diff..'|r)'
			else
				postfix = ' ('..'+'..diff..')'
			end
		else 
			if currentColor ~= "" then
				postfix = ' (|c'..currentColor..diff..'|r)'
			else
				postfix = ' ('..diff..')'
			end
		end
	end
	LDBLagTolerance.text = currentLagTolerance..' ms'..postfix
	LDBLagTolerance.value = currentLagTolerance
end

function LDBLagTolerance:Update()
	currentLagTolerance = select(3, GetNetStats())
	currentSetting = GetCVar("maxSpellStartRecoveryOffset")
	LDBLagTolerance:UpdateText()
	if LDBLagToleranceDB.autoChange then
		addon:ChangeLagTolerance()
	end
end

function addon:PLAYER_LOGIN()
	if (not LDBLagToleranceDB or not LDBLagToleranceDB.dbVersion or LDBLagToleranceDB.dbVersion < DBversion) then
		addon:setDefaults()
	end
end


function addon:ADDON_LOADED(name, event)
	if(name == addonName) then
		self:UnregisterEvent(event)
		self:PLAYER_LOGIN()
	end
end

function LDBLagTolerance:OnTooltipShow()
	self:AddLine(defaultText.." |cff00ff00"..addonversion.."|r")
	self:AddLine("|cffffffff"..L['Displays the current LagTolerance.  On click adjusts the combat LagTolerance accordingly.'].."|r")
end

function addon:setDefaults()
	LDBLagToleranceDB = LDBLagToleranceDB or {}
	LDBLagToleranceDB.autoChange = LDBLagToleranceDB.autoChange or false
	LDBLagToleranceDB.showDiff = LDBLagToleranceDB.showDiff or true
	LDBLagToleranceDB.dbVersion = DBversion
end

local options = {
	type ="group",
	name = defaultText,
	handler = LDBLagTolerance,
	childGroups = "tree",
	args = {
		header1 = {
			type = "description",
			name = L["Some useful description"],
			order = 0,
			width = "full",
			cmdHidden = true
		},
		spacer1 = {
			type = "header",
			name = "",
			order = 1,
			width = "full",
			cmdHidden = true
		},
		autoChange = {
			type = "toggle",
			name = L["Automatically change lag tolerance"],
			width = "full",
			order = 2,
			set = function (info, value)
				LDBLagToleranceDB.autoChange = value
			end,
			get = function() return LDBLagToleranceDB.autoChange end
		},
		showDifference = {
			type = "toggle",
			name = L["Show the difference between LagTolerance and log tolerance"],
			width = "full",
			order = 3,
			set = function (info, value)
				LDBLagToleranceDB.showDifference = value
			end,
			get = function() return LDBLagToleranceDB.showDifference end
		},
		--[[
		showPercent = {
			type = "toggle",
			name = L["Show percentage value"],
			width = "full",
			order = 3,
			set = function (info, value)
				LDBLagToleranceDB.showPercent = value
			end,
			get = function() return LDBLagToleranceDB.showPercent end
		},
		]]--
	},
}

local AceCfg = LibStub("AceConfig-3.0")
local AceCfgReg = LibStub("AceConfigRegistry-3.0")
local AceDlg = LibStub("AceConfigDialog-3.0")

AceCfg:RegisterOptionsTable("LDB_LagTolerance", options)

local brokerOptions = AceCfgReg:GetOptionsTable("Broker", "dialog", "LibDataBroker-1.1")
if (not brokerOptions) then
	brokerOptions = {
		type = "group",
		name = "Broker",
		args = {
		}
	}
	AceCfg:RegisterOptionsTable("Broker", brokerOptions)
	AceDlg:AddToBlizOptions("Broker", "Broker")
end

LDBLagTolerance.optionsFrame = AceDlg:AddToBlizOptions("LDB_LagTolerance", "LagTolerance", "Broker")

addon:RegisterEvent(IsAddOnLoaded('AddonLoader') and 'ADDON_LOADED' or 'PLAYER_LOGIN')
addon:SetScript('OnEvent', function(self, event, ...) self[event](self, ..., event) end)

LDBLagTolerance:ScheduleRepeatingTimer("Update", 30)
LDBLagTolerance:ScheduleTimer("Update", 4)
